window.Gleam.initSearch([{"doc":"glimmer","title":"glimmer","content":"# glimmer\n\n[![Package Version](https://img.shields.io/hexpm/v/glimmer)](https://hex.pm/packages/glimmer)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glimmer/)\n\nA Gleam project\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add glimmer\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/glimmer&gt;.\n","url":"index.html"},{"doc":"stream","title":"PipeMessage","content":"pub opaque type PipeMessage(a)\n the types of messages used within Glimmer, for Streams.\n\nSynonyms:\nstream.PipeMessage\nstream PipeMessage","url":"stream.html#PipeMessage"},{"doc":"stream","title":"Stream","content":"pub type Stream(a) {\n  Stream(process.Subject(PipeMessage(a)))\n}\n A concurrent stream of values.\n This isn&#39;t a datastructure per se, it&#39;s all lazy.\nStream(process.Subject(PipeMessage(a)))\n\n\nSynonyms:\nstream.Stream\nstream Stream","url":"stream.html#Stream"},{"doc":"stream","title":"close","content":"pub fn close(s: Stream(a)) -&gt; Nil\n Indicate that no more values will be sent in the stream.\n This is optional but useful if the stream is intended to model some finite datastructure,\n which many of these functions expect.\n This is an imperative, side-effectful procedure.\nSynonyms:\nstream.close\nstream close","url":"stream.html#close"},{"doc":"stream","title":"collect","content":"pub fn collect(s: Stream(a)) -&gt; List(a)\n Represent a stream as a list.\n This blocks until there&#39;s an indication that the stream is over.\n (See `close`)\nSynonyms:\nstream.collect\nstream collect","url":"stream.html#collect"},{"doc":"stream","title":"filter","content":"pub fn filter(input: Stream(a), p: fn(a) -&gt; Bool) -&gt; Stream(a)\n Filter elements out of a stream concurrently\n (as opposed to, say, calling `collect` and then using `list.filter`).\n Internally there is imperative dark magic but this presents\n a pure functional interface (if `p` is pure).\n This makes it great for pipes. For example,\n \n [1, 2, 3]\n |&gt; from_list\n |&gt; filter(fn(n) { n % 2 == 0 })\n |&gt; collect()\n |&gt; io.debug() // prints [1, 3]\n \nSynonyms:\nstream.filter\nstream filter","url":"stream.html#filter"},{"doc":"stream","title":"foreach","content":"pub fn foreach(stream: Stream(a), f: fn(a) -&gt; Nil) -&gt; Nil\n Perform a side-effect for each element in the stream, consuming it.\n This effect can include writing to another stream,\n so the elements aren&#39;t necessarily gone. For example:\n \n use &lt;- with(output_stream)\n use i &lt;- foreach(input_stream)\n output_stream |&gt; write(i * 2)\n \nSynonyms:\nstream.foreach\nstream foreach","url":"stream.html#foreach"},{"doc":"stream","title":"foreach_unless_error","content":"pub fn foreach_unless_error(stream: Stream(a), f: fn(a) -&gt;\n    Result(Nil, b)) -&gt; Result(Nil, b)\n Iterate through the elements in the stream until done or `Error`.\n Perform some computation each time.\n For example:\n \n use i &lt;- foreach_unless_error(input_stream)\n case i &lt; 0 {\n   True -&gt; Error(&quot;found a negative!&quot;)\n   False -&gt; Ok(Nil)\n }\n \nSynonyms:\nstream.foreach_unless_error\nstream foreach_unless_error","url":"stream.html#foreach_unless_error"},{"doc":"stream","title":"from_list","content":"pub fn from_list(l: List(a)) -&gt; Stream(a)\n Construct a stream from a list.\nSynonyms:\nstream.from_list\nstream from_list","url":"stream.html#from_list"},{"doc":"stream","title":"map","content":"pub fn map(input: Stream(a), f: fn(a) -&gt; b) -&gt; Stream(b)\n Map a function over a stream concurrently \n (as opposed to, say, calling `collect` and then using `list.map`).\n Internally there is imperative dark magic but this presents\n a pure functional interface (if `f` is pure). \n This makes it great for pipes. For example,\n \n [1, 2, 3]\n |&gt; from_list()\n |&gt; map(fn(n) { n + 1 })\n |&gt; map(fn(n) { n * 2 })\n |&gt; collect()\n |&gt; io.debug() // prints [4, 6, 8]\n \nSynonyms:\nstream.map\nstream map","url":"stream.html#map"},{"doc":"stream","title":"new","content":"pub fn new() -&gt; Stream(a)\n Construct a stream.\nSynonyms:\nstream.new\nstream new","url":"stream.html#new"},{"doc":"stream","title":"next","content":"pub fn next(s: Stream(a)) -&gt; Result(a, Nil)\n Get the next value from the stream. \n Wait if there isn&#39;t one yet.\nSynonyms:\nstream.next\nstream next","url":"stream.html#next"},{"doc":"stream","title":"next_with_timeout","content":"pub fn next_with_timeout(s: Stream(a), timeout: Int) -&gt; Result(\n  a,\n  Nil,\n)\n Get the next value from the stream.\n Wait if it isn&#39;t there yet, giving up if the timeout runs out.\nSynonyms:\nstream.next_with_timeout\nstream next_with_timeout","url":"stream.html#next_with_timeout"},{"doc":"stream","title":"reduce","content":"pub fn reduce(input: Stream(a), start: b, f: fn(a, b) -&gt; b) -&gt; b\n Reduce (or fold) a stream to a value.\n This is concurrent in the sense that reduction steps begin before\n the last value arrives, and may happen in parallel.\n However, the function won&#39;t return until all values are received, of course.\n Internally there is imperative dark magic but this presents\n a pure functional interface (if `f` is pure).\n This makes it great for pipes. For example,\n \n [1, 2, 3]\n |&gt; from_list\n |&gt; reduce(0, fn(a, b) { a + b })\n |&gt; io.debug() // prints 6\n \nSynonyms:\nstream.reduce\nstream reduce","url":"stream.html#reduce"},{"doc":"stream","title":"to_iterator","content":"pub fn to_iterator(s: Stream(a)) -&gt; Iterator(a)\n Represent a stream as a Gleam iterator.\nSynonyms:\nstream.to_iterator\nstream to_iterator","url":"stream.html#to_iterator"},{"doc":"stream","title":"with","content":"pub fn with(stream: Stream(a), f: fn() -&gt; b) -&gt; b\n Use a stream and then `close` it. \n This is intended for `use` syntax, for example:\n \n use &lt;- with(output_stream)\n write(out, &quot;hi&quot;)\n \nSynonyms:\nstream.with\nstream with","url":"stream.html#with"},{"doc":"stream","title":"write","content":"pub fn write(s: Stream(a), value: a) -&gt; Nil\n Write a value to a stream.\n This is an imperative, side-effectful procedure.\nSynonyms:\nstream.write\nstream write","url":"stream.html#write"},{"doc":"stream","title":"stream","content":" `glimmer/stream` introduces an abstraction over `gleam/erlang/process`, called a Stream.\n The goal of streams are to make parallelism free and easy by having it appear sequential.\n There are both functional and imperative (effectful) functions in this library.\n The imperative functions are most useful for getting a stream started:\n the options for filling up a fresh stream are basically just `write` which is imperative and\n `from_list` which is functional, and `write` will make more sense for many situations.\n Once a stream is going, and you just need to process it, then the functional functions\n (`map`, `filter`, `reduce`, `collect`, `to_iterator`) can be very ergonomic and sensible.\n Note: streams masquerade as lists, but they aren&#39;t datastructures. Reading from them consumes the items,\n which the functional functions get around by saving results in a new stream or datastructure.\n If you want something like array-indexing then you&#39;ll need to convert the stream into an \n actual datastructure, perhaps with `collect`, and likely lose any concurrency benefits.","url":"stream.html"}]);